// PXEWIN - (C) Copyright 1992 by Beam Engineering, INC.

// PXDIS.HPP //

// Contents ----------------------------------------------------------------
//
//	This module contains the PDIS class for initializing the database
//	table, record and fields.
//
// End ---------------------------------------------------------------------

// External Reference Name for this Header ---------------------------------

#ifndef PXDIS_HPP
	#define PXDIS_HPP

// End ---------------------------------------------------------------------

// Interface Dependencies --------------------------------------------------

#ifndef PXEOBJ_CPP
	#include "pxeobj.cpp"
#endif // PXEOBJ_CPP //

#ifndef PXTBL_CPP
	#include "pxtbl.cpp"
#endif // PXTBL_CPP //

#ifndef PXEREC_CPP
	#include "pxrec.cpp"
#endif // PXREC_CPP //

#ifndef PXFIELD_CPP
	#include "pxfield.cpp"
#endif // PXFIELD_CPP //

// End ---------------------------------------------------------------------

// class PXDIS //

_CLASSDEF(PXDIS)
class PXDIS:public PXEngObject
{
private:
	virtual const Pchar streamableName()
	const					/* Defines the streamable
						   name for this class. */
	{
		return "PXDIS";
	}
protected:
	virtual Pvoid read(Ripstream);		/* Read persistant object */
	virtual void write(Ropstream);		/* Write persistant object */
	PXDIS(StreamableInit):			/* Persistant object
						   constructor */
		PXEngObject(streamableInit)
	{

	}
public:
	PPXTbl my_table;			/* My table object */
	PPXRec my_record;			/* My Record object */
	PPPXField my_field;			/* Fields list */

	PXDIS();
	static PTStreamable build();		/* Build persistant object */
	int SetUp(int index,int mode,		/* Set up database */
		int op,int display);
	virtual ~PXDIS();			/* Destroy display */
	char *Get(int i);			/* Get the data from the
						   right field */
};

// Description -------------------------------------------------------------
//
//	This class intializes a table for displaying purposes.  It was
//	designed to use one record handle per table.  For the table is
//	opened without an index.  All fields are initialized.
//
// End ---------------------------------------------------------------------

// Define inserters and extractors for persistant objects:

inline Ripstream operator >> (Ripstream is,RPXDIS cl)
	{return is >> (RTStreamable)cl;}

inline Ripstream operator >> (Ripstream is,RPPXDIS cl)
	{return is >> (RPvoid)cl;}

inline Ropstream operator << (Ropstream os,RPXDIS cl)
	{return os << (RTStreamable)cl;}

inline Ropstream operator << (Ropstream os,PPXDIS cl)
	{return os << (PTStreamable)cl;}

#endif // PXDIS_HPP //